<?php
namespace FiloBlu\Storelocator\Model;

use Magento\Framework\Exception\LocalizedException as CoreException;

class WorkingTimes extends \Magento\Framework\Model\AbstractModel
{

    protected $workingTimesCollectionFactory;

    /**
     * Store manager
     *
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    protected $_storeManager;

    public function __construct(
        \FiloBlu\Storelocator\Model\ResourceModel\WorkingTimes\CollectionFactory $workingTimesCollectionFactory,
        \Magento\Store\Model\StoreManagerInterface $_storeManager,
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    )
    {
        $this->workingTimesCollectionFactory = $workingTimesCollectionFactory;
        $this->_storeManager = $_storeManager;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init('FiloBlu\Storelocator\Model\ResourceModel\WorkingTimes');
    }


    public function loadByStoreIdDayPeriod($storeId, $day, $period)
    {
        $collection = $this->workingTimesCollectionFactory->create();

        $collection
            ->addFieldToFilter('store_id', $storeId)
            ->addFieldToFilter('day', $day)
            ->addFieldToFilter('period', $period);
        return $collection->getFirstItem();
    }

    public function loadByStoreId($storeId)
    {
        $collection = $this->workingTimesCollectionFactory->create();

        $collection->addFieldToFilter('store_id', $storeId);
        $collection->setOrder('day', 'ASC');
        $collection->setOrder('period', 'ASC');

        return $collection;
    }

}